diff -Nrc2 fontutils-0.5/imageto/out-epsf.c fontutils-0.6/imageto/out-epsf.c
*** fontutils-0.5/imageto/out-epsf.c
--- fontutils-0.6/imageto/out-epsf.c	Fri Oct 16 15:46:50 1992
***************
*** 0 ****
--- 1,170 ----
+ /* out-epsf.c: output the whole image as an EPS file.
+ 
+ Copyright (C) 1992 Free Software Foundation, Inc.
+ 
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #include "config.h"
+ 
+ #include "hexify.h"
+ #include "report.h"
+ 
+ #include "main.h"
+ #include "out-epsf.h"
+ 
+ extern string version_string;
+ 
+ static void pack_scanline (one_byte *, unsigned);
+ 
+ /* Convert a number in pixels to big points, which are Adobe's units.
+    (72 big points to the inch.)  */
+ #define PIXELS_TO_BP(v, dpi) (72 * (v) / (dpi))
+ 
+ /* Abbreviations for output to `eps_file'.  */
+ #define OUT_STRING(s) fprintf (eps_file, "%s", s)
+ #define OUT_SIMPLE(s) fprintf (eps_file, "%%%%%s\n", s)
+ #define OUT_COMMENT(s, v) fprintf (eps_file, "%%%%%s: %s\n", s, v)
+ #define OUT1(s, v1) fprintf (eps_file, s, v1)
+ #define OUT2(s, v1, v2) fprintf (eps_file, s, v1, v2)
+ #define OUT3(s, v1, v2, v3) fprintf (eps_file, s, v1, v2, v3)
+ 
+ /* Write an Encapsulated PostScript file corresponding to the image.  */
+ 
+ void
+ write_epsf (string output_name, image_header_type image_header)
+ {
+   /* Just black & white, or do we have grayscale?  */
+   boolean monochrome_p = image_header.depth == 1;
+   
+   /* Just for convenience.  */
+   unsigned width = image_header.width;
+   unsigned height = image_header.height;
+   
+   /* We pack the image tightly if it's monochrome.  */
+   unsigned width_used = monochrome_p ? width / 8 + !!(width % 8) : width;
+ 
+   /* Buffer into which we'll read the image data.  */
+   unsigned scanline_count = 0;
+   one_byte *scanline = xmalloc (width);
+   
+   /* Open the output file OUTPUT_NAME.  */
+   FILE *eps_file = xfopen (output_name, "w");
+ 
+   OUT_STRING ("%!PS-Adobe-3.0 EPSF-3.0\n");
+   OUT2 ("%%%%BoundingBox: 0 0 %u %u\n", width, height);
+   OUT_COMMENT ("Creator", version_string);
+   OUT_COMMENT ("Title", output_name);
+   OUT_COMMENT ("CreationDate", now ());
+   OUT_COMMENT ("DocumentData", "Clean7Bit");
+   OUT_SIMPLE ("EndComments");
+   
+   /* We map the image to the unit square for image(mask) and scale the
+      coordinate system to get back to the original size.  I can't grasp
+      how to use the matrix argument to image(mask) to avoid the scaling,
+      but I'm sure it's possible. */
+   OUT2 ("gsave\n  %u %u scale\n", width, height);
+   
+   /* We need a buffer to hold the string chunks as we read them.  It
+      can't be of arbitrary size: it must be an exact multiple of the
+      total number of data characters.  Otherwise, we will read past the
+      end of the data.  */
+   OUT1 ("/image-buffer %u string def\n", width_used);
+   
+   /* If we are monochrome, we use the `imagemask' operator; else `image'.  */
+   OUT2 ("  %u %u", width, height);
+ 
+   if (monochrome_p)
+     OUT_STRING (" true"); /* The `invert' argument.  */
+   else
+     OUT1 (" %u", image_header.depth); /* bits/sample */
+   
+   OUT3 (" [%u 0 0 -%u 0 %u]\n", width, height, height);
+   OUT_STRING ("{currentfile image-buffer readhexstring pop}\n");
+   OUT1 ("%s\n", monochrome_p ? "imagemask" : "image");
+   
+   /* Read the image.  */
+   while ((*image_get_scanline) (scanline))
+     {
+       string h;
+       unsigned loc;
+ 
+       scanline_count++;
+       if (scanline_count % 10 == 0)
+         REPORT1 (".%s", scanline_count % 790 == 0 ? "\n" : "");
+       
+       /* Monochrome images are output with eight samples/byte; grayscale
+          images are output with one sample/byte.  */
+       if (monochrome_p)
+         pack_scanline (scanline, width);
+ 
+       /* Convert binary to ASCII hexadecimal.  */
+       h = hexify (scanline, width_used);
+ 
+       /* Adobe says lines in EPS files should be no more than 255
+          characters.  How silly.  */
+       for (loc = 1; loc <= 2 * width_used; loc++)
+         {
+           putc (h[loc - 1], eps_file);
+           if (loc % 255 == 0)
+             putc ('\n', eps_file);
+ 	}
+       
+       free (h);
+       putc ('\n', eps_file);
+     }
+   
+   /* Restore the ctm.  */
+   OUT_STRING ("grestore\n");
+ 
+   if (scanline_count != image_header.height)
+     WARNING2 ("Expected %u scanlines, read %u", image_header.height,
+               scanline_count); 
+   
+   OUT_SIMPLE ("TRAILER");
+   OUT_SIMPLE ("EOF");
+ }
+ 
+ /* Change the one bit/byte representation (call each byte a `cell') of
+    LENGTH bits in DATA to be eight bits/byte.  Pad the last byte with
+    zero.  We don't change those bytes beyond the end of packed portion,
+    thus assuming they are not looked at.  */
+ 
+ static void
+ pack_scanline (one_byte *data, unsigned length)
+ {
+   unsigned cell; /* Which bit in the original data we're on.  */
+   unsigned packing_loc = 0; /* Which byte we're currently packing.  */
+   unsigned packing_bit = 8; /* How much to shift.  */
+   
+   /* The very first cell has to be treated specially, because we must
+      initialize it with itself shifted left (if we're going to use data
+      in place, that is.)  */
+   data[0] <<= 7;
+   
+   for (cell = 0; cell < length; cell++)
+     {
+       packing_bit--;
+       data[packing_loc] |= data[cell] << packing_bit;
+       if (packing_bit == 0)
+         {
+           packing_bit = 8;
+           packing_loc++;
+           
+           /* After the first byte, we can just clear the byte at
+              `packing_loc', since `cell' has already moved beyond it.  */
+           data[packing_loc] = 0;
+ 	}
+     }
+ }
diff -Nrc2 fontutils-0.5/imageto/out-epsf.h fontutils-0.6/imageto/out-epsf.h
*** fontutils-0.5/imageto/out-epsf.h
--- fontutils-0.6/imageto/out-epsf.h	Fri Oct  2 16:26:23 1992
***************
*** 0 ****
--- 1,28 ----
+ /* out-epsf.h: output the whole image as an EPS file.
+ 
+ Copyright (C) 1992 Free Software Foundation, Inc.
+ 
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #ifndef OUT_EPSF_H
+ #define OUT_EPSF_H
+ 
+ #include "image-header.h"
+ 
+ 
+ /* Output an EPS file for the image with header H to OUTPUT_NAME.  */
+ extern void write_epsf (string output_name, image_header_type h);
+ 
+ #endif /* not OUT_EPSF_H */
diff -Nrc2 fontutils-0.5/imageto/out-strips.c fontutils-0.6/imageto/out-strips.c
*** fontutils-0.5/imageto/out-strips.c
--- fontutils-0.6/imageto/out-strips.c	Fri Oct  2 17:08:42 1992
***************
*** 0 ****
--- 1,94 ----
+ /* out-strips.c: cut the entire image into strips.
+ 
+ Copyright (C) 1992 Free Software Foundation, Inc.
+ 
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #include "config.h"
+ 
+ #include "gf.h"
+ #include "report.h"
+ 
+ #include "main.h"
+ #include "out-strips.h"
+ 
+ /* Output a ``font'' in which each ``character'' is a constant number of
+    scanlines from the image.  This might use less than resources than
+    the giant PostScript file that -epsf outputs.
+    
+    We only output the GF characters here; we assume the postamble and
+    preamble are written by the caller.  */
+ 
+ void
+ write_chars_as_strips (image_header_type image_header, real design_size)
+ {
+   dimensions_type char_dimens;
+   gf_char_type gf_char;
+   unsigned gf_row;
+   unsigned lines_per_char;
+   one_byte *scanline;
+   real width_in_points;
+   boolean first_char = true;
+   unsigned scanline_count = 0;
+ 
+   /* Set up for the first character.  We divide the image into 256 parts,
+      each of which will turn into one ``character''.  */
+   lines_per_char = image_header.height / 256 + 1;
+   GF_CHARCODE (gf_char) = 0;
+   DIMENSIONS_WIDTH (char_dimens) = image_header.width;
+   DIMENSIONS_HEIGHT (char_dimens) = lines_per_char;
+   GF_BITMAP (gf_char) = new_bitmap (char_dimens);
+   GF_CHAR_MIN_COL (gf_char) = GF_CHAR_MIN_ROW (gf_char) = 0;
+   GF_CHAR_MAX_COL (gf_char) = DIMENSIONS_WIDTH (char_dimens);
+   GF_CHAR_MAX_ROW (gf_char) = DIMENSIONS_HEIGHT (char_dimens) - 1;
+   
+   /* We aren't going to have any side bearings.  */
+   GF_H_ESCAPEMENT (gf_char) = DIMENSIONS_WIDTH (char_dimens);
+   width_in_points = DIMENSIONS_WIDTH (char_dimens) * POINTS_PER_INCH
+                     / (real) image_header.hres;
+   GF_TFM_WIDTH (gf_char) = real_to_fix (width_in_points / design_size);
+   
+   
+   /* Read the image.  */
+   while (true)
+     {
+       if (scanline_count % lines_per_char == 0)
+         {
+           /* We get here when scanline_count == 0, and we haven't read
+              anything, so we can't write anything.  */
+           if (!first_char)
+             {
+               gf_put_char (gf_char);
+               REPORT2 ("[%u]%c", GF_CHARCODE (gf_char),
+                                 (GF_CHARCODE (gf_char) + 1) % 13 ? ' ' : '\n');
+               GF_CHARCODE (gf_char)++;
+             }
+           else
+             first_char = false;
+           gf_row = 0;
+         }
+ 
+       scanline = BITMAP_BITS (GF_BITMAP (gf_char))
+                  + gf_row * DIMENSIONS_WIDTH (char_dimens); 
+       if (!(*image_get_scanline) (scanline)) break;
+ 
+       scanline_count++;
+       gf_row++;
+     }
+   
+   if (scanline_count != image_header.height)
+     WARNING2 ("Expected %u scanlines, read %u", image_header.height,
+               scanline_count); 
+ }
diff -Nrc2 fontutils-0.5/imageto/out-strips.h fontutils-0.6/imageto/out-strips.h
*** fontutils-0.5/imageto/out-strips.h
--- fontutils-0.6/imageto/out-strips.h	Fri Oct  2 17:08:42 1992
***************
*** 0 ****
--- 1,27 ----
+ /* out-strips.h: cut the image into strips.
+ 
+ Copyright (C) 1992 Free Software Foundation, Inc.
+ 
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #ifndef OUT_STRIPS_H
+ #define OUT_STRIPS_H
+ 
+ #include "image-header.h"
+ 
+ 
+ extern void write_chars_as_strips (image_header_type, real design_size);
+ 
+ #endif /* not OUT_STRIPS_H */
diff -Nrc2 fontutils-0.5/imageto/version.c fontutils-0.6/imageto/version.c
*** fontutils-0.5/imageto/version.c	Thu Sep  3 09:46:20 1992
--- fontutils-0.6/imageto/version.c	Tue Oct 27 13:27:59 1992
***************
*** 1 ****
! char *version_string = "imageto version 0.5";
--- 1 ----
! char *version_string = "imageto version 0.6";
diff -Nrc2 fontutils-0.5/imgrotate/.gdbinit fontutils-0.6/imgrotate/.gdbinit
*** fontutils-0.5/imgrotate/.gdbinit	Fri Aug 14 12:07:45 1992
--- fontutils-0.6/imgrotate/.gdbinit	Fri Oct  2 14:23:30 1992
***************
*** 16,19 ****
  #set args -verbose -flip  -output-file ../ourfonts/garamond/img/tsch.img \
  #  ../ourfonts/garamond/img/180/tsch
! set args -verbose -flip -output-file ../ourfonts/garamond/r/percent/rperc.img \
!   ../ourfonts/garamond/r/percent/perc
--- 16,24 ----
  #set args -verbose -flip  -output-file ../ourfonts/garamond/img/tsch.img \
  #  ../ourfonts/garamond/img/180/tsch
! #set args -verbose -flip -output-file ../ourfonts/garamond/r/percent/rperc.img \
! #  ../ourfonts/garamond/r/percent/perc
! #set args -verbose -rotate $ourfonts/bodoni/gbdb.gmi
! #set args -verbose -flip -output-file ../ourfonts/garamond/r/section/sect.gmi \
! #  ../ourfonts/garamond/r/section/sect
! set args -verbose -flip -output-file ../ourfonts/garamond/rq/vswash/vswsh.img \
!   ../ourfonts/garamond/rq/vswash/vswsh
diff -Nrc2 fontutils-0.5/imgrotate/ChangeLog fontutils-0.6/imgrotate/ChangeLog
*** fontutils-0.5/imgrotate/ChangeLog	Thu Sep  3 09:30:58 1992
--- fontutils-0.6/imgrotate/ChangeLog	Tue Oct 27 13:02:50 1992
***************
*** 1,2 ****
--- 1,10 ----
+ Tue Oct 27 13:02:09 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* Version 0.6.
+ 
+ Fri Oct 16 08:41:36 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* main.c (USAGE): Doc fix.
+ 
  Thu Sep  3 09:30:58 1992  Karl Berry  (karl@hayley)
  
diff -Nrc2 fontutils-0.5/imgrotate/main.c fontutils-0.6/imgrotate/main.c
*** fontutils-0.5/imgrotate/main.c	Fri Jun  5 09:20:25 1992
--- fontutils-0.6/imgrotate/main.c	Fri Oct 16 09:54:31 1992
***************
*** 266,274 ****
  "flip: rotate the image 180 degrees.
  help: print this message.
! output-file <filename>: write the output to <filename> if <filname> has
!    a suffix, otherwise write to <filename>.img; the default is the input
!    filename, if the input file directory is different from the execution
!    directory, or the input filename prepended with `x', if the
!    directories are the same.
  rotate-clockwise: rotate the image 90 degrees clockwise.
  verbose: output progress reports to stdout.
--- 266,272 ----
  "flip: rotate the image 180 degrees.
  help: print this message.
! output-file <filename>: write the output to <filename>, extended with
!    `.img' if <filename> does not have a suffix.  The default is the input
!    filename, prepended with `x' if that would overwrite the input file.
  rotate-clockwise: rotate the image 90 degrees clockwise.
  verbose: output progress reports to stdout.
diff -Nrc2 fontutils-0.5/imgrotate/version.c fontutils-0.6/imgrotate/version.c
*** fontutils-0.5/imgrotate/version.c	Thu Sep  3 09:46:21 1992
--- fontutils-0.6/imgrotate/version.c	Tue Oct 27 13:28:00 1992
***************
*** 1 ****
! char *version_string = "imgrotate version 0.5";
--- 1 ----
! char *version_string = "imgrotate version 0.6";
diff -Nrc2 fontutils-0.5/include/ChangeLog fontutils-0.6/include/ChangeLog
*** fontutils-0.5/include/ChangeLog	Thu Sep  3 09:31:02 1992
--- fontutils-0.6/include/ChangeLog	Tue Oct 27 13:02:50 1992
***************
*** 1,2 ****
--- 1,55 ----
+ Tue Oct 27 13:02:44 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* Version 0.6.
+ 
+ Sun Oct 25 06:27:11 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* getopt.h: New version.
+ 
+ Sat Oct 17 19:36:59 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* c-memstr.h (bcmp, bcopy, bzero): Only #define if they are not
+ 	already #define'd.
+ 
+ Tue Oct  6 09:04:23 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* bzr.h (BZR_CHAR_BB, etc.): Remove, as the CHAR_... macros work fine.
+ 
+ 	* tfm.h (TFM_SAFE_FONTDIMEN): Fully parenthesize.
+ 
+ Mon Oct  5 10:06:28 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* report.h (report_file): New variable.
+         (REPORT*): Use it.
+ 
+ Sun Oct  4 09:03:07 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* font.h (CHAR_HEIGHT): Just return the max row, don't add one for
+ 	the baseline.  Why did we want to do this?
+ 
+ 	* lib.h: Doc fix.
+ 
+ 	* bb-list.h: New file, taken from bb-outline.h; rename
+ 	`bounding_box_list' to prefix `bb_list'.
+ 
+ Fri Oct  2 17:01:25 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* report.h (REPORT): Use fputs instead of fprintf.
+ 	* logreport.h (LOG): Likewise.
+ 
+ Tue Sep 15 08:38:19 1992  Karl Berry  (karl@hayley)
+ 
+         * pbmplus.h: include config.h, and remove the old sysv/bsd
+           configuration stuff.
+ 
+ Tue Sep  8 17:05:33 1992  Karl Berry  (karl@hayley)
+ 
+         * c-auto.h.in (_MINIX, _{ALL,POSIX,POSIX_1}_SOURCE): add #undef's
+           for configure to define.
+ 
+ Sun Sep  6 16:54:48 1992  Karl Berry  (karl@hayley)
+ 
+         * global.h (MAX_INT_LENGTH): increase to 21, for 64-bit numbers.
+ 
  Thu Sep  3 09:31:02 1992  Karl Berry  (karl@hayley)
  
diff -Nrc2 fontutils-0.5/include/bb-list.h fontutils-0.6/include/bb-list.h
*** fontutils-0.5/include/bb-list.h
--- fontutils-0.6/include/bb-list.h	Sun Oct  4 09:25:11 1992
***************
*** 0 ****
--- 1,53 ----
+ /* bb-list.h: bounding box lists.
+ 
+ Copyright (C) 1992 Free Software Foundation, Inc.
+ 
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #ifndef BB_LIST_H
+ #define BB_LIST_H
+ 
+ #include "bounding-box.h"
+ 
+ 
+ typedef struct
+ {
+   bounding_box_type *data;
+   unsigned length;
+ } bb_list_type;
+ 
+ /* The length of the list.  */
+ #define BB_LIST_LENGTH(bb_l) ((bb_l).length)
+ 
+ /* The array of elements as a whole.  */
+ #define BB_LIST_DATA(bb_l) ((bb_l).data)
+ 
+ /* The Nth element in the list.  */
+ #define BB_LIST_ELT(bb_l, n) BB_LIST_DATA (bb_l)[n]
+ 
+ 
+ /* Initialize a list.  */
+ extern bb_list_type bb_list_init (void);
+ 
+ /* Append BB to L.  */
+ extern void bb_list_append (bb_list_type *l, bounding_box_type bb);
+ 
+ /* Splice the elements in list B2 onto B1, changing B1.  */
+ extern void bb_list_splice (bb_list_type *B1, bb_list_type B2);
+ 
+ /* Free the memory in a list.  */
+ extern void bb_list_free (bb_list_type *);
+ 
+ #endif /* not BB_LIST_H */
diff -Nrc2 fontutils-0.5/include/bb-outline.h fontutils-0.6/include/bb-outline.h
*** fontutils-0.5/include/bb-outline.h	Tue Jun  2 18:07:46 1992
--- fontutils-0.6/include/bb-outline.h	Sun Oct  4 09:25:11 1992
***************
*** 20,23 ****
--- 20,24 ----
  #define BB_OUTLINE_H
  
+ #include "bb-list.h"
  #include "bitmap.h"
  #include "types.h"
***************
*** 24,44 ****
  
  
- /* This is a list of bounding boxes enclosing outlines.  */
- typedef struct
- {
-   bounding_box_type *data;
-   unsigned length;
- } bounding_box_list_type;
- 
- /* The length of the list.  */
- #define BB_LIST_LENGTH(bb_l)  ((bb_l).length)
- 
- /* The array of elements as a whole.  */
- #define BB_LIST_DATA(bb_l)  ((bb_l).data)
- 
- /* The Nth element in the list.  */
- #define BB_LIST_ELT(bb_l, n)  ((bb_l).data[n])
- 
- 
  /* Find the bounding boxes around the outlines in the bitmap B.  If ALL is
     true, we find the bounding boxes around all the outlines, including
--- 25,28 ----
***************
*** 47,64 ****
     box.  We don't look in any of the columns from LEFT to RIGHT,
     left-inclusive.  */
! extern bounding_box_list_type
    find_outline_bbs (bitmap_type b, boolean all, int left, int right);
- 
- /* Initialize a list.  */
- extern bounding_box_list_type init_bounding_box_list (void);
- 
- /* Move all the elements in L to the right by OFFSET.  */
- extern void offset_bounding_box_list (bounding_box_list_type *l, int offset);
- 
- /* Append the elements in list B2 to B1, changing B1.  */
- extern void append_bounding_box_list (bounding_box_list_type *B1,
-                                       bounding_box_list_type B2);
- /* Free the memory in a list.  */
- extern void free_bounding_box_list (bounding_box_list_type *);
  
  #endif /* not BB_OUTLINE_H */
--- 31,36 ----
     box.  We don't look in any of the columns from LEFT to RIGHT,
     left-inclusive.  */
! extern bb_list_type
    find_outline_bbs (bitmap_type b, boolean all, int left, int right);
  
  #endif /* not BB_OUTLINE_H */
diff -Nrc2 fontutils-0.5/include/bzr.h fontutils-0.6/include/bzr.h
*** fontutils-0.5/include/bzr.h	Mon Aug 31 20:05:12 1992
--- fontutils-0.6/include/bzr.h	Sun Oct 18 17:06:59 1992
***************
*** 1,3 ****
--- 1,5 ----
  /* bzr.h: manipulate Bezier-format font files.  See ../bzr/README
+ 
+ 
     for the precise definition of the file format.
  
***************
*** 81,91 ****
  /* The character bounding box is not guaranteed to be the tightest
     possible, but it should be close.  The values are in points.  The
!    CHAR_HEIGHT, CHAR_DEPTH, CHAR_LSB, and CHAR_RSB macros work.  */
! #define BZR_CHAR_BB(c) ((c).bb)
! #define BZR_CHAR_MIN_COL(c) MIN_COL (BZR_CHAR_BB (c))
! #define BZR_CHAR_MAX_COL(c) MAX_COL (BZR_CHAR_BB (c))
! #define BZR_CHAR_MIN_ROW(c) MIN_ROW (BZR_CHAR_BB (c))
! #define BZR_CHAR_MAX_ROW(c) MAX_ROW (BZR_CHAR_BB (c))
! #define BZR_CHAR_BB_WIDTH(c) BB_WIDTH (BZR_CHAR_BB (c))
  
  /* The shape is given as a list of lists of lines and cubic splines.
--- 83,88 ----
  /* The character bounding box is not guaranteed to be the tightest
     possible, but it should be close.  The values are in points.  The
!    CHAR_HEIGHT, CHAR_DEPTH, CHAR_SET_WIDTH, CHAR_BB, and related macros
!    in `font.h' all work.  */
  
  /* The shape is given as a list of lists of lines and cubic splines.
diff -Nrc2 fontutils-0.5/include/c-auto.h.in fontutils-0.6/include/c-auto.h.in
*** fontutils-0.5/include/c-auto.h.in	Thu Apr 23 07:42:23 1992
--- fontutils-0.6/include/c-auto.h.in	Tue Sep  8 17:08:35 1992
***************
*** 1,4 ****
--- 1,10 ----
  /* c-auto.h.in: template for c-auto.h.  */
  
+ /* These are needed on some Unix variants to get POSIX facilities.  */
+ #undef _ALL_SOURCE
+ #undef _MINIX
+ #undef _POSIX_SOURCE
+ #undef _POSIX_1_SOURCE
+ 
  /* Define if your system has <dirent.h>.  */
  #undef DIRENT
diff -Nrc2 fontutils-0.5/include/c-memstr.h fontutils-0.6/include/c-memstr.h
*** fontutils-0.5/include/c-memstr.h	Wed Jul 22 08:50:54 1992
--- fontutils-0.6/include/c-memstr.h	Sat Oct 17 19:37:23 1992
***************
*** 28,34 ****
--- 28,40 ----
  #define index strchr
  #define rindex strrchr
+ #ifndef bcmp
  #define bcmp(s1, s2, len) memcmp ((s1), (s2), (len))
+ #endif
+ #ifndef bcopy
  #define bcopy(from, to, len) memcpy ((to), (from), (len))
+ #endif
+ #ifndef bzero
  #define bzero(s, len) memset ((s), 0, (len))
+ #endif
  #else
  #include <strings.h>
diff -Nrc2 fontutils-0.5/include/font.h fontutils-0.6/include/font.h
*** fontutils-0.5/include/font.h	Sun Jun 14 15:15:17 1992
--- fontutils-0.6/include/font.h	Sun Oct  4 14:24:59 1992
***************
*** 149,155 ****
  
  
! /* The height of a character is how far it extends above the baseline,
!    including the row of pixels on the baseline.  */
! #define CHAR_HEIGHT(c) (CHAR_MAX_ROW (c) >= 0 ? CHAR_MAX_ROW (c) + 1 : 0)
  
  /* The depth is far it extends below the baseline (but as a positive
--- 149,154 ----
  
  
! /* The height of a character is how far it extends above the baseline.  */
! #define CHAR_HEIGHT(c) (CHAR_MAX_ROW (c) >= 0 ? CHAR_MAX_ROW (c) : 0)
  
  /* The depth is far it extends below the baseline (but as a positive
diff -Nrc2 fontutils-0.5/include/getopt.h fontutils-0.6/include/getopt.h
*** fontutils-0.5/include/getopt.h	Wed Aug 19 14:47:22 1992
--- fontutils-0.6/include/getopt.h	Wed Oct 21 11:43:35 1992
***************
*** 87,99 ****
  /* Names for the values of the `has_arg' field of `struct option'.  */
  
! enum _argtype
! {
!   no_argument,
!   required_argument,
!   optional_argument
! };
  
  #if __STDC__
  extern int getopt (int argc, char *const *argv, const char *shortopts);
  extern int getopt_long (int argc, char *const *argv, const char *shortopts,
  		        const struct option *longopts, int *longind);
--- 87,103 ----
  /* Names for the values of the `has_arg' field of `struct option'.  */
  
! #define	no_argument		0
! #define required_argument	1
! #define optional_argument	2
  
  #if __STDC__
+ #if defined(__GNU_LIBRARY__)
+ /* Many other libraries have conflicting prototypes for getopt, with
+    differences in the consts, in stdlib.h.  To avoid compilation
+    errors, only prototype getopt for the GNU C library.  */
  extern int getopt (int argc, char *const *argv, const char *shortopts);
+ #else /* not __GNU_LIBRARY__ */
+ extern int getopt ();
+ #endif /* not __GNU_LIBRARY__ */
  extern int getopt_long (int argc, char *const *argv, const char *shortopts,
  		        const struct option *longopts, int *longind);
diff -Nrc2 fontutils-0.5/include/global.h fontutils-0.6/include/global.h
*** fontutils-0.5/include/global.h	Fri Jun 26 16:48:54 1992
--- fontutils-0.6/include/global.h	Sun Sep  6 16:59:09 1992
***************
*** 61,67 ****
  /* Define useful abbreviations.  */
  
! /* This is the maximum number of numerals that result when a 32-bit
!    integer is converted to a string, plus one for a trailing null.  */
! #define MAX_INT_LENGTH  11
  
  /* Printer's points, as defined by TeX (and good typesetters everywhere).  */
--- 61,68 ----
  /* Define useful abbreviations.  */
  
! /* This is the maximum number of numerals that result when a 64-bit
!    integer is converted to a string, plus one for a trailing null byte,
!    plus one for a sign.  */
! #define MAX_INT_LENGTH 21
  
  /* Printer's points, as defined by TeX (and good typesetters everywhere).  */
diff -Nrc2 fontutils-0.5/include/lib.h fontutils-0.6/include/lib.h
*** fontutils-0.5/include/lib.h	Wed Apr 29 15:47:05 1992
--- fontutils-0.6/include/lib.h	Sun Oct  4 09:25:12 1992
***************
*** 67,71 ****
  extern address xcalloc P2H(unsigned nelem, unsigned elsize);
  
! /* (Re)Allocate N items of type T using malloc, or fail.  */
  #define XTALLOC(n, t) (t *) xmalloc ((n) * sizeof (t))
  #define XTALLOC1(t) XTALLOC (1, t)
--- 67,71 ----
  extern address xcalloc P2H(unsigned nelem, unsigned elsize);
  
! /* (Re)Allocate N items of type T using xmalloc/xrealloc.  */
  #define XTALLOC(n, t) (t *) xmalloc ((n) * sizeof (t))
  #define XTALLOC1(t) XTALLOC (1, t)
diff -Nrc2 fontutils-0.5/include/logreport.h fontutils-0.6/include/logreport.h
*** fontutils-0.5/include/logreport.h	Mon Jun  1 15:47:29 1992
--- fontutils-0.6/include/logreport.h	Fri Oct  2 17:02:50 1992
***************
*** 35,39 ****
  
  #define LOG(s)								\
!   do { if (logging) fprintf (log_file, s); } while (0)
  #define LOG1(s, e)							\
    do { if (logging) fprintf (log_file, s, e); } while (0)
--- 35,39 ----
  
  #define LOG(s)								\
!   do { if (logging) fputs (s, log_file); } while (0)
  #define LOG1(s, e)							\
    do { if (logging) fprintf (log_file, s, e); } while (0)
diff -Nrc2 fontutils-0.5/include/pbmplus.h fontutils-0.6/include/pbmplus.h
*** fontutils-0.5/include/pbmplus.h	Sat Mar  7 10:05:36 1992
--- fontutils-0.6/include/pbmplus.h	Tue Sep 15 08:37:54 1992
***************
*** 9,12 ****
--- 9,14 ----
  ** documentation.  This software is provided "as is" without express or
  ** implied warranty.
+ 
+    Configuration options modified for GNU --karl.
  */
  
***************
*** 18,21 ****
--- 20,27 ----
  #include <stdio.h>
  
+ #include "config.h"
+ 
+ 
+ #if 0 /* karl */
  #if ! ( defined(BSD) || defined(SYSV) || defined(MSDOS))
  /* CONFIGURE: If your system is >= 4.2BSD, set the BSD option; if you're a
***************
*** 28,31 ****
--- 34,38 ----
  /* #define MSDOS */
  #endif
+ #endif
  
  /* CONFIGURE: If you want to enable writing "raw" files, set this option.
***************
*** 87,90 ****
--- 94,98 ----
  /* #define DEBUG */
  
+ #if 0 /* karl */
  #ifdef SYSV
  #include <string.h>
***************
*** 99,102 ****
--- 107,111 ----
  #include <strings.h>
  #endif /*SYSV*/
+ #endif /* 0 */
  
  /* CONFIGURE: On some systems, malloc.h doesn't declare these, so we have
diff -Nrc2 fontutils-0.5/include/report.h fontutils-0.6/include/report.h
*** fontutils-0.5/include/report.h	Fri Mar 27 14:55:09 1992
--- fontutils-0.6/include/report.h	Mon Oct  5 10:12:32 1992
***************
*** 24,27 ****
--- 24,30 ----
  
  
+ /* The file we write information to.  */
+ extern FILE *report_file;
+ 
  /* Only print anything if this is true.  */
  extern boolean verbose;
***************
*** 29,50 ****
  
  #define REPORT(s)							\
!   do if (verbose) { fprintf (stderr, s); fflush (stderr); }		\
    while (0)
  
  #define REPORT1(s, e)							\
!   do if (verbose) { fprintf (stderr, s, e); fflush (stderr); }		\
    while (0)
  
  #define REPORT2(s, e1, e2)						\
!   do if (verbose) { fprintf (stderr, s, e1, e2); fflush (stderr); }	\
    while (0)
  
  #define REPORT3(s, e1, e2, e3)						\
!   do if (verbose) { fprintf (stderr, s, e1, e2, e3); fflush (stderr); }	\
    while (0)
  
  #define REPORT4(s, e1, e2, e3, e4)					\
!   do if (verbose) { fprintf (stderr, s, e1, e2, e3, e4);		\
! 		    fflush (stderr); } 					\
    while (0)
  
--- 32,55 ----
  
  #define REPORT(s)							\
!   do if (verbose) { fputs (s, report_file); fflush (report_file); }	\
    while (0)
  
  #define REPORT1(s, e)							\
!   do if (verbose) { fprintf (report_file, s, e); fflush (report_file); }\
    while (0)
  
  #define REPORT2(s, e1, e2)						\
!   do if (verbose) { fprintf (report_file, s, e1, e2);			\
!                     fflush (report_file); }				\
    while (0)
  
  #define REPORT3(s, e1, e2, e3)						\
!   do if (verbose) { fprintf (report_file, s, e1, e2, e3);		\
!                     fflush (report_file); }				\
    while (0)
  
  #define REPORT4(s, e1, e2, e3, e4)					\
!   do if (verbose) { fprintf (report_file, s, e1, e2, e3, e4);		\
! 		    fflush (report_file); } 				\
    while (0)
  
diff -Nrc2 fontutils-0.5/include/tfm.h fontutils-0.6/include/tfm.h
*** fontutils-0.5/include/tfm.h	Tue Jul  7 16:43:56 1992
--- fontutils-0.6/include/tfm.h	Tue Oct  6 11:21:16 1992
***************
*** 105,109 ****
  #define TFM_SAFE_FONTDIMEN(info, number, ret)				\
    ((number) - 1 < TFM_FONTDIMEN_COUNT (info) 				\
!    ? TFM_FONTDIMEN (info, number) : ret)
  
  /* Define symbolic names for the numbers of the parameters we
--- 105,109 ----
  #define TFM_SAFE_FONTDIMEN(info, number, ret)				\
    ((number) - 1 < TFM_FONTDIMEN_COUNT (info) 				\
!    ? TFM_FONTDIMEN (info, number) : (ret))
  
  /* Define symbolic names for the numbers of the parameters we
